import cv2
import numpy as np
import math
import os

from SteganographyApp.EncodeApp.StegoEncodeApp.KeyToBlock import RotadeTokenKey
from SteganographyApp.EncodeApp.StegoEncodeApp.BitData import R_reverseBits


def modifyBit( n,  p,  b):
    mask = 1 << p
    return (n & ~mask) | ((b << p) & mask)

def XorBits(num):
    bitSize=8
    binary = bin(num)
    reverse = binary[-1:1:-1]
    reverse = reverse + (bitSize - len(reverse)) * '0'

    sayac = 0
    for i in range(1,8):
        if int(reverse[i]) == 1:
            sayac = sayac + 1

    if sayac % 2 == 0:
        return (0)
    elif sayac % 2 == 1:
        return (1)
    else:
        return (0)

def GetBit(num, bitSize = 8):

    binary = bin(num)
    reverse = binary[-1:1:-1]
    reverse = reverse + (bitSize - len(reverse)) * '0'

    # last bit
    data = int(reverse[0])

    return(data)


def stego_decode_tum_sirali(rgb_slct, blok_slct, limit, stego_data, token_key):

    outfile_path = "StegoDecodeApp/GetMsgBinData.txt"
    outbin_file = open(outfile_path, "w")

    frm_count = len([item for item in os.listdir('StegoDecodeApp/Frame') if
                     os.path.isfile(os.path.join('StegoDecodeApp/Frame', item))])

    size = cv2.imread('StegoDecodeApp/Frame/frame0.png', cv2.IMREAD_COLOR)
    h, w, z = size.shape  # height, width, channel

    data_matrix = np.zeros(((h * w * frm_count), 6))

    limit = limit - 1
    t = 0
    hide_frm_count = 0

    w_blk = int(w / 64)
    h_blk = int(h / 64)
    blok_count = w_blk * h_blk
    cnt=0

    for ifr in range(0,frm_count,1):
        input_image = ('StegoDecodeApp/Frame/frame' + str(ifr) + '.png')
        img = cv2.imread(input_image, cv2.IMREAD_COLOR)
        out_img = np.zeros((h, w, 3), np.uint8)
        hide_frm_count = hide_frm_count + 1
        ring_num = 1  # blok gösterimi için
        hide_blok = 0
        for mi in range(0, (int(h / 64) * 64), 64):
            for mj in range(0, (int(w / 64) * 64), 64):
                hide_blok = hide_blok + 1
                durum = True
                key_frm = False
                out_key = np.zeros((64, 64, 3), np.uint8)  
                for ki in range(0, (64), 16):
                    for kj in range(0, (64), 16):
                        for i in range(16):
                            yon = True
                            for j in range(16):
                                if token_key[i + ki][j + kj] == 1 and yon and hide_blok < blok_count:
                                    if durum:
                                        pb, pg, pr = img[mi + i + ki][mj + j + kj]
                                        data_matrix[cnt][0] = ifr
                                        data_matrix[cnt][1] = ring_num
                                        data_matrix[cnt][2] = mj + j + kj
                                        data_matrix[cnt][3] = mi + i + ki
                                        data_matrix[cnt][4] = 1
                                        data_matrix[cnt][5] = 0
                                        cnt += 1
                                        opr = opg = opb = 255
                                        key_frm = True
                                        rb, rg, rr = img[mi + i + ki][
                                            mj + j + kj]  
                                        npr = pr
                                        npg = pg
                                        npb = pb
                                        
                                        if rgb_slct == 'RGB':
                                            rbit_ch1 = rb
                                            rbit_ch2 = rg
                                        elif rgb_slct == 'B':
                                            rbit_ch1 = rg
                                            rbit_ch2 = rr
                                        elif rgb_slct == 'G':
                                            rbit_ch1 = rb
                                            rbit_ch2 = rr
                                        elif rgb_slct == 'R':
                                            rbit_ch1 = rb
                                            rbit_ch2 = rg

                                    else:
                                        if (mi + ki + i) <= int(h / 64) * 64 and (mj + kj + j) <= int(
                                                w / 64) * 64:
                                            npb, npg, npr = img[mi + i + ki][mj + j + kj]
                                            opb = opg = opr = 0
                                    
                                    if rgb_slct == 'RGB':
                                        ch1 = npb
                                        ch2 = npg
                                    elif rgb_slct == 'B':
                                        ch1 = npg
                                        ch2 = npr
                                    elif rgb_slct == 'G':
                                        ch1 = npb
                                        ch2 = npr
                                    elif rgb_slct == 'R':
                                        ch1 = npb
                                        ch2 = npg

                                    
                                    if XorBits(ch1) or XorBits(ch2) == 0:
                                        durum = False  
                                    if XorBits(ch1) and XorBits(ch2) == 0:
                                        yon = False  

                                else:
                                    if (mi + ki + i) <= int(h / 64) * 64 and (mj + kj + j) <= int(w / 64) * 64:
                                        npb, npg, npr = img[mi + i + ki][mj + j + kj]
                                        opb = opg = opr = 0
                                        data_matrix[cnt][0] = ifr
                                        data_matrix[cnt][1] = ring_num
                                        data_matrix[cnt][2] = mj + j + kj
                                        data_matrix[cnt][3] = mi + i + ki
                                        data_matrix[cnt][4] = 0
                                        data_matrix[cnt][5] = 0
                                        cnt += 1

                                out_key[i + ki][j + kj] = [opb, opg, opr]
                                if mi + ki + i <= int(h / 64) * 64 and mj + kj + j <= int(w / 64) * 64:
                                    out_img[mi + i + ki][mj + j + kj] = [npb, npg, npr]

                
                if key_frm:
                    ring_num += 1
    
    durum_sayac = 0
    for j in range(cnt):
        if data_matrix[j][4] == 1:
            durum_sayac += 1
   
    sb = int(durum_sayac / frm_count)
   
    ind = 0
    dt = 1
    while dt <= int(limit):  
        if ind < cnt:
            if int(data_matrix[ind][4] == 1) and int(data_matrix[ind][5]) == 0:
                data_matrix[ind][5] = 1
                ind += sb
                dt += 1
            else:
                ind += 1
        else:
            ind = (ind - cnt) + sb

    sayac = 0

    for j in range(cnt):
        if data_matrix[j][5] == 1:
            sayac += 1
   
    t = 0
    strt = 0
    for ifr in range(frm_count):
        input_image = ('StegoDecodeApp/Frame/frame' + str(ifr) + '.png')
        img = cv2.imread(input_image, cv2.IMREAD_COLOR)
        
        for dt_frm in range(strt, cnt):
            if data_matrix[dt_frm][0] == ifr and data_matrix[dt_frm][5] == 1:
                pb, pg, pr = img[int(data_matrix[dt_frm][3])][int(data_matrix[dt_frm][2])]
                if rgb_slct == 'RGB':
                    if t < limit:
                        data = GetBit(pb)
                        outbin_file.writelines(str(data))
                        t = t + 1
                    if t < limit:
                        data = GetBit(pg)
                        outbin_file.writelines(str(data))
                        t = t + 1
                    if t < limit:
                        data = GetBit(pr)
                        outbin_file.writelines(str(data))
                        t = t + 1
                elif rgb_slct == 'R':
                    if t < limit:
                        data = GetBit(pr)
                        outbin_file.writelines(str(data))
                        t = t + 1
                elif rgb_slct == "G":
                    if t < limit:
                        data = GetBit(pg)
                        outbin_file.writelines(str(data))
                        t = t + 1
                elif rgb_slct == "B":
                    if t < limit:
                        data = GetBit(pb)
                        outbin_file.writelines(str(data))
                        t = t + 1
                strt += 1

    outbin_file.close()






















