import cv2
import numpy as np
import math
import os

from SteganographyApp.DecodeApp.GetMsg.GetMsg import message
from SteganographyApp.DecodeApp.StegoDecodeApp.KeyToBlock import RotadeTokenKey
from SteganographyApp.DecodeApp.StegoDecodeApp.BitData import R_reverseBits

def GetBit(num, bitSize = 8):

    binary = bin(num)
    reverse = binary[-1:1:-1]
    reverse = reverse + (bitSize - len(reverse)) * '0'

    # last bit
    data = int(reverse[0])

    return(data)

def XorBits(num):
    bitSize=8
    binary = bin(num)
    reverse = binary[-1:1:-1]
    reverse = reverse + (bitSize - len(reverse)) * '0'

    sayac = 0
    for i in range(1,8):
        if int(reverse[i]) == 1:
            sayac = sayac + 1

    if sayac % 2 == 0:
        return (0)
    elif sayac % 2 == 1:
        return (1)
    else:
        return (0)


def stego_decode(rgb_slct, blok_slct, limit, stego_data, token_key):
    

    outfile_path = "StegoDecodeApp/GetMsgBinData.txt"
    outbin_file = open(outfile_path,"w")
    
    frm_count = len([item for item in os.listdir('StegoDecodeApp/Frame') if os.path.isfile(os.path.join('StegoDecodeApp/Frame', item))])
    size = cv2.imread('StegoDecodeApp//Frame/frame0.png', cv2.IMREAD_COLOR)
    h, w, z = size.shape  # height, width, channel

    limit  = limit-1
    t=0
    hide_frm_count = 0

    w_blk = int(w / 64)
    h_blk = int(h / 64)
    blok_count = w_blk * h_blk
   
    for ifr in range(0, frm_count, 1):
        input_image = ('StegoDecodeApp/Frame/frame' + str(ifr) + '.png')
        img = cv2.imread(input_image, cv2.IMREAD_COLOR)

        if t < limit:
            hide_frm_count = hide_frm_count + 1
            ring_num = 1  
            hide_blok = 0
            for mi in range(0, (int(h / 64) * 64), 64):
                for mj in range(0, (int(w / 64) * 64), 64):
                    hide_blok = hide_blok + 1
                    durum = True
                    out_key = np.zeros((64, 64, 3), np.uint8)  
                    for ki in range(0, (64), 16):
                        for kj in range(0, (64), 16):
                            for i in range(16):
                                yon = True
                                for j in range(16):
                                    if token_key[i + ki][j + kj] == 1 and yon and hide_blok < blok_count:
                                        pb, pg, pr = img[mi + i + ki][mj + j + kj]
                                        if durum:
                                            if rgb_slct == 'RGB':
                                                if t < limit:
                                                    data = GetBit(pb)
                                                    outbin_file.writelines(str(data))
                                                    t = t+1
                                                    rb, rg, rr = img[mi + i + ki][mj + j + kj] 
                                                    rbit_ch1 = rg
                                                    rbit_ch2 = rr
                                                if t < limit:
                                                    data = GetBit(pg)
                                                    outbin_file.writelines(str(data))
                                                    t = t + 1
                                                    rb, rg, rr = img[mi + i + ki][mj + j + kj]
                                                    rbit_ch1 = rb
                                                    rbit_ch2 = rr
                                                if t < limit:
                                                    data = GetBit(pr)
                                                    outbin_file.writelines(str(data))
                                                    t = t + 1
                                                    rb, rg, rr = img[mi + i + ki][mj + j + kj]
                                                    rbit_ch1 = rb
                                                    rbit_ch2 = rg
                                            elif rgb_slct == 'R':
                                                if t < limit:
                                                    data = GetBit(pr)
                                                    outbin_file.writelines(str(data))
                                                    t = t + 1
                                                    rb, rg, rr = img[mi + i + ki][mj + j + kj]
                                                    rbit_ch1 = rb
                                                    rbit_ch2 = rg
                                            elif rgb_slct == 'G':
                                                if t < limit:
                                                    data = GetBit(pg)
                                                    outbin_file.writelines(str(data))
                                                    t = t + 1
                                                    rb, rg, rr = img[mi + i + ki][mj + j + kj]
                                                    rbit_ch1 = rb
                                                    rbit_ch2 = rr
                                            elif rgb_slct == 'B':
                                                pb, pg, pr = img[mi + i + ki][mj + j + kj]
                                                if t < limit:
                                                    data = GetBit(pb)
                                                    outbin_file.writelines(str(data))
                                                    t = t + 1
                                                    rb, rg, rr = img[mi + i + ki][mj + j + kj]
                                                    rbit_ch1 = rg
                                                    rbit_ch2 = rr
                                        
                                        if rgb_slct == 'RGB':
                                            ch1 = pb
                                            ch2 = pg
                                        elif rgb_slct == 'B':
                                            ch1 = pg
                                            ch2 = pr
                                        elif rgb_slct == 'G':
                                            ch1 = pb
                                            ch2 = pr
                                        elif rgb_slct == 'R':
                                            ch1 = pb
                                            ch2 = pg
                                        if XorBits(ch1) or XorBits(ch2) == 0:
                                            durum = False  
                                        
                                        if XorBits(ch1) and XorBits(ch2) == 0:
                                            yon = False 
                    

    outbin_file.close()
    message()
    return(0)

















