import cv2
import numpy as np
import math
import os

from SteganographyApp.EncodeApp.StegoEncodeApp.KeyToBlock import RotadeTokenKey
from SteganographyApp.EncodeApp.StegoEncodeApp.BitData import R_reverseBits


def modifyBit( n,  p,  b):
    mask = 1 << p
    return (n & ~mask) | ((b << p) & mask)

def XorBits(num):
    bitSize=8
    binary = bin(num)
    reverse = binary[-1:1:-1]
    reverse = reverse + (bitSize - len(reverse)) * '0'

    sayac = 0
    for i in range(1,8):
        if int(reverse[i]) == 1:
            sayac = sayac + 1

    if sayac % 2 == 0:
        return (0)
    elif sayac % 2 == 1:
        return (1)
    else:
        return (0)

def stego_encode_sirali(blok_slct, rgb_slct, token_key):
   
    
    input_msg='InputMsg/InputBinaryData.txt'
    in_file = open(input_msg, "r+")
    msg = in_file.read()
    in_file.close()
    limit = msg.__len__()
    t=0
    hide_frm_count=0

    
    frm_count = len([item for item in os.listdir('Frame') if os.path.isfile(os.path.join('Frame', item))])
    size = cv2.imread('Frame/frame0.png', cv2.IMREAD_COLOR)
    h, w, z = size.shape  # height, width, channel

    
    w_blk = int(w / 64)
    h_blk = int(h / 64)
    blok_count = w_blk * h_blk


    for ifr in range(0,frm_count,1):
        input_image = ('Frame/frame' + str(ifr) + '.png')
        img = cv2.imread(input_image, cv2.IMREAD_COLOR)
        out_img = np.zeros((h, w, 3), np.uint8)
        out_key_frm = np.zeros((h, w, 3), np.uint8) 
        out_data_frm = np.zeros((h, w, 3), np.uint8)  

        if t < limit:
            hide_frm_count = hide_frm_count + 1
            ring_num = 1
            hide_blok = 0
            for mi in range(0, (int(h / 64) * 64), 64):
                for mj in range(0, (int(w / 64) * 64), 64):
                    hide_blok = hide_blok + 1
                    durum = True
                    key_frm = False
                    out_key = np.zeros((64, 64, 3), np.uint8)  
                    for ki in range(0, (64), 16):
                        for kj in range(0, (64), 16):
                            for i in range(16):
                                yon = True
                                for j in range(16):
                                    if token_key[i + ki][j + kj] == 1 and yon and hide_blok < blok_count:
                                        if durum:
                                            if rgb_slct == 'RGB':
                                                pb, pg, pr = img[mi + i + ki][mj + j + kj]
                                                if t < limit:
                                                    npb = (modifyBit(pb, 0, int(msg[t])))
                                                    t = t + 1
                                                    opb = 255
                                                    key_frm = True
                                                    rb, rg, rr = img[mi + i + ki][
                                                        mj + j + kj]  
                                                    rbit_ch1 = rg
                                                    rbit_ch2 = rr
                                                else:
                                                    npb = pb
                                                    opb = 0
                                                if t < limit:
                                                    npg = (modifyBit(pg, 0, int(msg[t])))
                                                    t = t + 1
                                                    opg = 255
                                                    key_frm = True
                                                    rb, rg, rr = img[mi + i + ki][mj + j + kj]
                                                    rbit_ch1 = rb
                                                    rbit_ch2 = rr
                                                else:
                                                    npg = pg
                                                    opg = 0
                                                if t < limit:
                                                    npr = (modifyBit(pr, 0, int(msg[t])))
                                                    t = t + 1
                                                    opr = 255
                                                    key_frm = True
                                                    rb, rg, rr = img[mi + i + ki][mj + j + kj]
                                                    rbit_ch1 = rb
                                                    rbit_ch2 = rg
                                                else:
                                                    npr = pr
                                                    opr = 0
                                            elif rgb_slct == 'R':
                                                pb, pg, pr = img[mi + i + ki][mj + j + kj]
                                                if t < limit:
                                                    npr = (modifyBit(pr, 0, int(msg[t])))
                                                    npg = pg
                                                    npb = pb
                                                    t = t + 1
                                                    opr = opg = opb = 255
                                                    key_frm = True
                                                    rb, rg, rr = img[mi + i + ki][mj + j + kj]
                                                    rbit_ch1 = rb
                                                    rbit_ch2 = rg
                                                else:
                                                    npr = pr
                                                    npg = pg
                                                    npb = pb
                                                    opr = opg = opb = 0
                                            elif rgb_slct == 'G':
                                                pb, pg, pr = img[mi + i + ki][mj + j + kj]
                                                if t < limit:
                                                    npg = (modifyBit(pg, 0, int(msg[t])))
                                                    npb = pb
                                                    npr = pr
                                                    t = t + 1
                                                    opr = opg = opb = 255
                                                    key_frm = True
                                                    rb, rg, rr = img[mi + i + ki][mj + j + kj]
                                                    rbit_ch1 = rb
                                                    rbit_ch2 = rr
                                                else:
                                                    npr = pr
                                                    npg = pg
                                                    npb = pb
                                                    opr = opg = opb = 0
                                            elif rgb_slct == 'B':
                                                pb, pg, pr = img[mi + i + ki][mj + j + kj]
                                                if t < limit:
                                                    npb = (modifyBit(pb, 0, int(msg[t])))
                                                    npg = pg
                                                    npr = pr
                                                    t = t + 1
                                                    opr = opg = opb = 255
                                                    key_frm = True
                                                    rb, rg, rr = img[mi + i + ki][mj + j + kj]
                                                    rbit_ch1 = rg
                                                    rbit_ch2 = rr
                                                else:
                                                    npr = pr
                                                    npg = pg
                                                    npb = pb
                                                    opr = opg = opb = 0
                                            out_key_frm[mi + i + ki][mj + j + kj] = [npb, npg, npr]
                                            out_data_frm[mi + i + ki][mj + j + kj] = [opb, opg, opr]
                                        else:
                                            if (mi + ki + i) <= int(h / 64) * 64 and (mj + kj + j) <= int(
                                                    w / 64) * 64:
                                                npb, npg, npr = img[mi + i + ki][mj + j + kj]
                                                opb = opg = opr = 0
                                        
                                        if rgb_slct=='RGB':
                                            ch1=npb
                                            ch2=npg
                                        elif rgb_slct=='B':
                                            ch1= npg
                                            ch2= npr
                                        elif rgb_slct=='G':
                                            ch1= npb
                                            ch2= npr
                                        elif rgb_slct=='R':
                                            ch1= npb
                                            ch2= npg

                                        
                                        if XorBits(ch1) or XorBits(ch2) == 0:
                                            durum =  False  
                                        
                                        if XorBits(ch1) and XorBits(ch2) == 0:
                                            yon = False  
                                         

                                    else:
                                        if (mi + ki + i) <= int(h / 64) * 64 and (mj + kj + j) <= int(w / 64) * 64:
                                            npb, npg, npr = img[mi + i + ki][mj + j + kj]
                                            opb = opg = opr = 0

                                    out_key[i + ki][j + kj] = [opb, opg, opr]
                                    if mi + ki + i <= int(h / 64) * 64 and mj + kj + j <= int(w / 64) * 64:
                                        out_img[mi + i + ki][mj + j + kj] = [npb, npg, npr]                    
                    if key_frm:
                        out_ring_img = ('StegoEncodeAppFiles/HideBlokFrame/out_kyf' + str(ifr) + '-' + str(
                            ring_num) + '.png')
                        cv2.imwrite(out_ring_img, out_key)
                        ring_num += 1
            cv2.imwrite('StegoEncodeAppFiles/HideDataFrame/frame' + str(ifr) + '.png', out_key_frm)
            cv2.imwrite('StegoEncodeAppFiles/HideOutDataFrame/frame' + str(ifr) + '.png', out_data_frm)
            
            if (mi + 64) < h:
                for oi in range((mi + 64), h, 1):
                    for oj in range(w):
                        out_img[oi][oj] = img[oi][oj]
                
            if (mj + 64) < w:
                for oi in range(h):
                    for oj in range((mj + 64), w, 1):
                        out_img[oi][oj] = img[oi][oj]
            
        else:
            out_img = img
        cv2.imwrite('StegoEncodeApp/outFrame/frame'+str(ifr)+'.png',out_img)


    return hide_frm_count
























