import cv2
import numpy as np
import math
import os

from SteganographyApp.EncodeApp.StegoEncodeApp.KeyToBlock import RotadeTokenKey
from SteganographyApp.EncodeApp.StegoEncodeApp.BitData import R_reverseBits


def modifyBit( n,  p,  b):
    mask = 1 << p
    return (n & ~mask) | ((b << p) & mask)

def XorBits(num):
    bitSize=8
    binary = bin(num)
    reverse = binary[-1:1:-1]
    reverse = reverse + (bitSize - len(reverse)) * '0'

    sayac = 0
    for i in range(1,8):
        if int(reverse[i]) == 1:
            sayac = sayac + 1

    if sayac % 2 == 0:
        return (0)
    elif sayac % 2 == 1:
        return (1)
    else:
        return (0)

def stego_encode_tum_sirali(blok_slct, rgb_slct, token_key):

       
    input_msg='InputMsg/InputBinaryData.txt'
    in_file = open(input_msg, "r+")
    msg = in_file.read()
    in_file.close()
    limit = msg.__len__()
    t=0
    hide_frm_count=0

    
    frm_count = len([item for item in os.listdir('Frame') if os.path.isfile(os.path.join('Frame', item))])
    size = cv2.imread('Frame/frame0.png', cv2.IMREAD_COLOR)
    h, w, z = size.shape  # height, width, channel

    data_matrix=np.zeros(((h*w*frm_count),6))


    
    w_blk = int(w / 64)
    h_blk = int(h / 64)
    blok_count = w_blk * h_blk
    cnt=0

    
    for ifr in range(0,frm_count,1):
        input_image = ('Frame/frame' + str(ifr) + '.png')
        img = cv2.imread(input_image, cv2.IMREAD_COLOR)
        out_img = np.zeros((h, w, 3), np.uint8)
        hide_frm_count = hide_frm_count + 1
        ring_num = 1  # blok gösterimi için
        hide_blok = 0
        for mi in range(0, (int(h / 64) * 64), 64):
            for mj in range(0, (int(w / 64) * 64), 64):
                hide_blok = hide_blok + 1
                durum = True
                key_frm = False
                out_key = np.zeros((64, 64, 3), np.uint8)  
                for ki in range(0, (64), 16):
                    for kj in range(0, (64), 16):
                        for i in range(16):
                            yon = True
                            for j in range(16):
                                if token_key[i + ki][j + kj] == 1 and yon and hide_blok < blok_count:
                                    if durum:
                                        pb, pg, pr = img[mi + i + ki][mj + j + kj]
                                        
                                        data_matrix[cnt][0] = ifr
                                        data_matrix[cnt][1] = ring_num
                                        data_matrix[cnt][2] = mj + j + kj
                                        data_matrix[cnt][3] = mi + i + ki
                                        data_matrix[cnt][4] = 1
                                        data_matrix[cnt][5] = 0
                                        cnt += 1
                                        opr = opg = opb = 255
                                        key_frm = True
                                        rb, rg, rr = img[mi + i + ki][
                                            mj + j + kj]  
                                        npr = pr
                                        npg = pg
                                        npb = pb
                                        
                                        if rgb_slct == 'RGB':
                                            rbit_ch1 = rb
                                            rbit_ch2 = rg
                                        elif rgb_slct == 'B':
                                            rbit_ch1 = rg
                                            rbit_ch2 = rr
                                        elif rgb_slct == 'G':
                                            rbit_ch1 = rb
                                            rbit_ch2 = rr
                                        elif rgb_slct == 'R':
                                            rbit_ch1 = rb
                                            rbit_ch2 = rg

                                    else:
                                        if (mi + ki + i) <= int(h / 64) * 64 and (mj + kj + j) <= int(
                                                w / 64) * 64:
                                            npb, npg, npr = img[mi + i + ki][mj + j + kj]
                                            opb = opg = opr = 0
                                    
                                    if rgb_slct == 'RGB':
                                        ch1 = npb
                                        ch2 = npg
                                    elif rgb_slct == 'B':
                                        ch1 = npg
                                        ch2 = npr
                                    elif rgb_slct == 'G':
                                        ch1 = npb
                                        ch2 = npr
                                    elif rgb_slct == 'R':
                                        ch1 = npb
                                        ch2 = npg

                                    
                                    if XorBits(ch1) or XorBits(ch2) == 0:
                                        durum = False  
                                    
                                    if XorBits(ch1) and XorBits(ch2) == 0:
                                        yon = False  
                                else:
                                    if (mi + ki + i) <= int(h / 64) * 64 and (mj + kj + j) <= int(w / 64) * 64:
                                        npb, npg, npr = img[mi + i + ki][mj + j + kj]
                                        opb = opg = opr = 0
                                        data_matrix[cnt][0] = ifr
                                        data_matrix[cnt][1] = ring_num
                                        data_matrix[cnt][2] = mj + j + kj
                                        data_matrix[cnt][3] = mi + i + ki
                                        data_matrix[cnt][4] = 0
                                        data_matrix[cnt][5] = 0
                                        cnt += 1

                                out_key[i + ki][j + kj] = [opb, opg, opr]
                                if mi + ki + i <= int(h / 64) * 64 and mj + kj + j <= int(w / 64) * 64:
                                    out_img[mi + i + ki][mj + j + kj] = [npb, npg, npr]

               
                if key_frm:
                    ring_num += 1
    
    
    durum_sayac = 0
    for j in range(cnt):
        if data_matrix[j][4] == 1:
            durum_sayac += 1
    
    sb = int(durum_sayac / frm_count)   
    ind = 0
    dt = 1
    while dt <= int(limit): 
        if ind < cnt:
            if int(data_matrix[ind][4] == 1) and int(data_matrix[ind][5]) == 0:
                data_matrix[ind][5] = 1
                ind += sb
                dt += 1
            else:
                ind += 1
        else:
            ind = (ind - cnt) + sb

    sayac = 0
    frm0 = 0
    frm1 = 0
    frm2 = 0
    for j in range(cnt):
        if data_matrix[j][5] == 1:
            sayac += 1
           
            if data_matrix[j][0] == 0:
                frm0 += 1
            if data_matrix[j][0] == 1:
                frm1 += 1
            if data_matrix[j][0] == 2:
                frm2 += 1
   
    t = 0
    strt = 0
    for ifr in range(frm_count):
        out_key_frm = np.zeros((h, w, 3), np.uint8)  # h,w
        input_image = ('Frame/frame' + str(ifr) + '.png')
        img = cv2.imread(input_image, cv2.IMREAD_COLOR)
        out_img = np.zeros((h, w, 3), np.uint8)

        for mi in range(0, h):
            for mj in range(0, w):
                pb, pg, pr = img[mi][mj]
                out_img[mi][mj] = [pb, pg, pr]

        for dt_frm in range(strt, cnt):
            if data_matrix[dt_frm][0] == ifr and data_matrix[dt_frm][5] == 1:
                pb, pg, pr = img[int(data_matrix[dt_frm][3])][int(data_matrix[dt_frm][2])]
                if rgb_slct == 'RGB':
                    if t < limit:
                        pb = (modifyBit(pb, 0, int(msg[t])))
                        t = t + 1
                    if t < limit:
                        pg = (modifyBit(pg, 0, int(msg[t])))
                        t = t + 1
                    if t < limit:
                        pr = (modifyBit(pr, 0, int(msg[t])))
                        t = t + 1
                elif rgb_slct == 'R':
                    if t < limit:
                        pr = (modifyBit(pr, 0, int(msg[t])))
                        t = t + 1
                elif rgb_slct == "G":
                    if t < limit:
                        pg = (modifyBit(pg, 0, int(msg[t])))
                        t = t + 1
                elif rgb_slct == "B":
                    if t < limit:
                        pb = (modifyBit(pb, 0, int(msg[t])))
                        t = t + 1
                strt += 1
                out_img[int(data_matrix[dt_frm][3])][int(data_matrix[dt_frm][2])] = [pb, pg, pr]
                out_key_frm[int(data_matrix[dt_frm][3])][int(data_matrix[dt_frm][2])] = [255, 255, 255]
        cv2.imwrite('StegoEncodeApp/outFrame/frame' + str(ifr) + '.png', out_img)
        cv2.imwrite('StegoEncodeAppFiles/HideDataFrame/frame' + str(ifr) + '.png', out_key_frm)

    
    data_out_path = "StegoEncodeAppFiles/data_matrix.txt"
    out_file = open(data_out_path, "w+", encoding="utf-8")
    for i in range(cnt):
        new_data = (str(int(data_matrix[i][0])), " >> ", str(int(data_matrix[i][1])),
                        " >> ", str(int(data_matrix[i][2])), " >> ", str(int(data_matrix[i][3])),
                        " >> ", str(int(data_matrix[i][4])), " >> ", str(int(data_matrix[i][5])))
        out_file.writelines(new_data)
        new_data="\n"
        out_file.writelines(new_data)
    out_file.close()

   





















